=== debian/changelog ===
ros-noetic-tesseract-kinematics (0.4.1-1buster) buster; urgency=high



 -- Levi Armstrong <levi.armstrong@swri.org>  Sat, 24 Apr 2021 05:00:00 -0000

ros-noetic-tesseract-kinematics (0.4.0-1buster) buster; urgency=high

  * Move srdf code to its own package tesseract_srdf
  * Contributors: Levi Armstrong

 -- Levi Armstrong <levi.armstrong@swri.org>  Fri, 23 Apr 2021 05:00:00 -0000

ros-noetic-tesseract-kinematics (0.3.1-1buster) buster; urgency=high

  * Move tesseract_variables() before any use of custom macros
  * Contributors: Levi Armstrong

 -- Levi Armstrong <levi.armstrong@swri.org>  Wed, 14 Apr 2021 05:00:00 -0000

ros-noetic-tesseract-kinematics (0.3.0-1buster) buster; urgency=high

  * Only enable code coverage if compiler definition is set
  * Fix satisfiesPositionLimits to use relative equal and calculation of redundant solutions to include all permutations
  * Fix inv kinematics to only return solution within limits and add redundant solutions for kdl ik solvers
  * Add cmake format
  * Add kinematics utility function for calculating manipulability (#571 <https://github.com/ros-industrial-consortium/tesseract/issues/571>)
  * Use boost targets, add cpack and license file (#572 <https://github.com/ros-industrial-consortium/tesseract/issues/572>)
  * Add kinematics utility function isNearSingularity (#569 <https://github.com/ros-industrial-consortium/tesseract/issues/569>)
  * Fix the way in which Eigen is included (#570 <https://github.com/ros-industrial-consortium/tesseract/issues/570>)
  * Fix checkJoints in UR Kinematics
  * Add universal robot inverse kinematics
  * Fix kinematics checkJoints not returning false when outside limits (#564 <https://github.com/ros-industrial-consortium/tesseract/issues/564>)
  * Add ability to construct ROP and REP kinematic solver with different solver names
  * Fix IKFast inverse kinematics wrapper
  * Update forward kinematics interface to return solutions versus out parameters
  * Update inverse kinematics interface to return solutions versus out parameters
  * Contributors: Hervé Audren, Levi Armstrong

 -- Levi Armstrong <levi.armstrong@swri.org>  Fri, 09 Apr 2021 05:00:00 -0000

ros-noetic-tesseract-kinematics (0.2.0-1buster) buster; urgency=high

  * Improve tesseract_kinematics test coverage (#543 <https://github.com/ros-industrial-consortium/tesseract/issues/543>)
  * Add another test case for kinematics core harmonize function
  * Fix harmonizeTowardZero
  * Update cmake_common_scripts to ros_industrial_cmake_boilerplate
  * Improve code coverage for tesseract_kinematics core
  * Move all directories in tesseract directory up one level
  * Contributors: Levi Armstrong

 -- Levi Armstrong <levi.armstrong@swri.org>  Wed, 17 Feb 2021 06:00:00 -0000

ros-noetic-tesseract-kinematics (0.1.0-1buster) buster; urgency=high

  * Update tesseract_kinematics to leverage tesseract_scene_graph
  * Fix depends in tesseract_kinematics
  * Semi-Isolate Tesseract Kinematics
  * Contributors: Levi Armstrong

 -- Levi Armstrong <levi.armstrong@swri.org>  Thu, 31 Dec 2020 06:00:00 -0000
